(function ($, Drupal) {
    "use strict";

    Drupal.behaviors.orejime = {
        attach: function (context, settings) {
            window.orejimeConfig = OrejimeConfig.init(context, settings);
        }
    };

    var OrejimeConfig = {
        init: function (context, settings) {
            var lang = settings.orejime.language;
            var config = {
                elementID : 'orejime',
                // appElement: "#app",
                lang: lang,
                cookieName: settings.orejime.cookie_name,
                cookieExpiresAfterDays: settings.orejime.expires_after_days,
                mustConsent: settings.orejime.must_consent,
                mustNotice: settings.orejime.must_notice,
                implicitConsent: settings.orejime.implicit_consent,
                privacyPolicy: settings.orejime.privacy_policy,
                default: true,
                translations: {},
                debug : settings.orejime.debug,
                apps: []
            };
            config['translations'][lang] = $.extend({}, settings.orejime.texts, {'purposes' : {}});
            $.each(settings.orejime.purposes, function (index, value) {
                config['translations'][lang]['purposes'][value] = value;
            });

            $.each(settings.orejime.manage, function (index, value) {
                config['translations'][lang][index] = {'description': value.description};
                config['apps'].push({
                    name: index,
                    title: value.label,
                    purposes: value.purposes,
                    cookies: value.cookies,
                    required: parseInt(value.required),
                    default: parseInt(value.default)
                });
            });
            return config;
        }
    };
})(jQuery, Drupal);
